//definition of a Sprite class for the animation demo
#include <PocketFrog.h>

#define ANGLE_360	1440
#define ANGLE_90	 360
#define ANGLE_60     240
#define ANGLE_30	 120
#define ANGLE_0		   0

#define ANGULAR_INCREMENT ((float)0.25)

#define DEG_TO_RAD	((float)3.1414926/(float)180)
#define RAD_TO_DEG  ((float)180/(float)3.1414926)

#define DISP_X		240
#define DISP_Y		320

#define WORLD_X_SIZE	512
#define WORLD_Y_SIZE	512

using namespace Frog;

struct TDistInfo
{
       float rayLength;
       float stepSize;
	   int   numRays;
	   int   lineThickness;
	   int   perspectiveLookup[256];
};
TDistInfo distInfo[100];

class VoxelDemo : public Game
{
public:
  
    VoxelDemo();//constructor
    virtual ~VoxelDemo();//destructor

	virtual void DrawTerrain(int play_x,int play_y,int play_z,int play_ang,int play_dist, Pixel *buffer, Pixel *texture, unsigned char *height);
	virtual void InitTables();
	virtual void InitHeightMap();
	virtual bool GameInit();
	virtual void GameLoop();
	virtual void GameEnd();

private:
    DisplayDevice* m_display;
    Surface* TextureData;
	Surface* HeightData;
	Surface::LockInfo BackBuffer;
	Surface::LockInfo TextureBuffer;
	Surface::LockInfo HeightBuffer;
	int Width;//width of 1 frame of loaded image
	int Depth;//height of the loaded image/bitmap
};